/*
 * Licensed Materials - Use restricted. For use in compiling interfaces to
 * IBM Rational TestManager.
 * (c) Copyright IBM Corporation 2001,2002,2006.  All Rights Reserved.
 */

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
// Includes
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////


#include <windows.h>
#include <tchar.h>
#include "OrdinalRecordingAdapter.h"
#include "proxutil.h"
		
// initialize global for library ID
int gbLibID = 0;


////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
// Function Definitions
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
int WINAPI DllMain(HANDLE hInstance,
				   ULONG ul_reason_being_called,
				   LPVOID lpReserved)
{

	switch (ul_reason_being_called)
	{
		case DLL_PROCESS_ATTACH:
		{
			// MUST call the following in DLL_PROCESS_ATTACH
			// this function is provided by the Utility DLL
			// rtxvutil.dll

			// the name passed-in must be the exact name of 
			// your wrapper DLL
			gbLibID = ProxyGetAssignedLibraryID("OrdinalRecordingAdapter.dll");

			// add whatever initialization you need here
			break;

		}

        case DLL_PROCESS_DETACH:
		{
			
			// add whatever cleanup you may need here
			break;
		}

		default:
		{
			break;
		}
    }

	return 1;
}






BOOL
IsAPIRecorderAdapter()
{

	return TRUE;
}

int
GetApiRecAdapterInfo(TCHAR* szBuffer, int iSize)
{
	static TCHAR szInfo[] =
		"OrdinalRecordingAdapter.dll,"     // name of recorder dll
		"HelloWorldTestDll.dll,"  // name of target dll
		"HelloWorldProtocol," 		// name of Protocol
		"HelloWorld Test Dll Recorder," // Optional - description of this recorder
		"1.0"; // Optional - version

		strcpy(szBuffer, szInfo);
		return 0;
}

LPSTR
GetApiAndWrapperNamePairs(int *iNumPairs)
{
	static TCHAR szPairs[] = 
		
		"1,pHelloWorld1,2,pHelloWorld2";

	*iNumPairs = 2;

	return szPairs;
}
