/*
 * Licensed Materials - Use restricted. For use in compiling interfaces to
 * IBM Rational TestManager.
 * (c) Copyright IBM Corporation 2001,2002,2006.  All Rights Reserved.
 */

#include "stdafx.h"
#include "CustomRecordingAdapter.h"
#include "CustomConfigurationUI.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define RSR_EXT_STUB_SILENT "RSR_EXT_STUB_SILENT"

#include <iostream.h>
#include <fstream.h>


static TCHAR optionValues[RSR_MAX_OPTIONS];

char buf2;
CCustomConfigurationUI	dlgCustomConfiguration;



extern "C" 
BOOL LINKDLL IsCustomRecorderAdapter()
{
    if(!GetEnvironmentVariable(RSR_EXT_STUB_SILENT,&buf2,0))
		MessageBox(NULL, "IsRecorderAdapter: TRUE",
                       "Hello from Custom Recording Adapter Stub!", MB_OK);
    return TRUE; 
} 


extern "C"
int LINKDLL GetDisplayName(TCHAR* name, 
                           size_t nameSize)
{
    _tcscpy(name, "Cust Rec Adapter#2");
    return RSR_SUCCESS;
}


extern "C" 
int LINKDLL GetOptions(TCHAR* options, 
                       size_t optionsSize)
{
    _tcscpy(options, _T(""));

    TCHAR opVar[4096];    

    if (::GetEnvironmentVariable(_T("RSR_CUST_REC_OPTIONS"), opVar, 4096) != 0)
    {    
        _tcscpy(options, opVar);
        return RSR_SUCCESS;
    }

    _tcscat(options, SESSION_FILES);
    _tcscat(options, _T(",xml,ext"));
    _tcscat(options, _T(";"));
    _tcscat(options, GENERAL_START_APP_PROMPT);
	_tcscat(options, _T(";"));
    _tcscat(options, GENERATOR_USE_DATAPOOLS);
	_tcscat(options, _T(";"));
    _tcscat(options, RECORD_SPLIT);
	_tcscat(options, _T(";"));
    _tcscat(options, RECORD_START_APP);
	_tcscat(options, _T(";"));
    _tcscat(options, RECORD_TIMER);
	_tcscat(options, _T(";"));
    _tcscat(options, RECORD_COMMENT);
	_tcscat(options, _T(";"));
    _tcscat(options, RECORD_SYNC_PT);
	_tcscat(options, _T(";"));
    _tcscat(options, RECORD_BLOCK);
	_tcscat(options, _T(";"));
    _tcscat(options, CONFIGURATION);
	_tcscat(options, _T(",a,b,c,d,e,f"));
	_tcscat(options, _T(";"));
	_tcscat(options, CONFIGURATION);
	_tcscat(options, _T(",g,h,i"));
	_tcscat(options, _T(";"));
	_tcscat(options, CONFIGURATION);
	_tcscat(options, _T(",USE_CUSTOM_UI"));

    
    
    if(!GetEnvironmentVariable(RSR_EXT_STUB_SILENT,&buf2,0))
	{
		MessageBox(NULL, "GetOptions: ",
                       "Hello from Custom Recording Adapter Stub!", MB_OK);
		MessageBox(NULL, options,
                       "Hello from Custom Recording Adapter Stub!", MB_OK);
	}
    if (_tcslen(options)+1 > optionsSize)
        return RSR_BUFFER_TOO_SHORT;
    else
        return RSR_SUCCESS;
}


extern "C" 
int LINKDLL SetOptions(TCHAR *options, 
                       size_t optionsSize,
                       TCHAR* errorMessage,
                       size_t errorMessageSize)
{
    if (optionsSize > RSR_MAX_OPTIONS)
        return RSR_BUFFER_TOO_SHORT;
    _tcscpy(optionValues, options);
	TCHAR buf[1024];
	sprintf(buf,"setting options: %s",options);
	if(!GetEnvironmentVariable(RSR_EXT_STUB_SILENT,&buf2,0))
	{
		MessageBox(NULL, buf,"", MB_OK);
		MessageBox(NULL, "SetOptions: ",
                       "Hello from Custom Recording Adapter Stub!", MB_OK);
		MessageBox(NULL, options,
                       "Hello from Custom Recording Adapter Stub!", MB_OK);
	}
    return RSR_SUCCESS;
}


extern "C" 
int LINKDLL DisplayCustomConfigGUI(TCHAR* errorMessage, 
                                   size_t errorMessageSize)
{
    AFX_MANAGE_STATE(AfxGetStaticModuleState());
	
	if(!dlgCustomConfiguration.m_hWnd)
	{
		dlgCustomConfiguration.Create(IDD_CUSTOM_CONFIGURATION_UI);
		dlgCustomConfiguration.ShowWindow(SW_SHOW);
	}
	else if(!dlgCustomConfiguration.IsWindowVisible())
		dlgCustomConfiguration.ShowWindow(SW_SHOW);
	else
		dlgCustomConfiguration.BringWindowToTop();

	
	return RSR_SUCCESS;
} 


extern "C" 
int LINKDLL InitializeRecorder(TCHAR* errorMessage, 
                               size_t errorMessageSize)
{
    if(!GetEnvironmentVariable(RSR_EXT_STUB_SILENT,&buf2,0))
		MessageBox(NULL, "InitializeRecorder",
                       "Hello from Custom RecordingAdapter Stub!", MB_OK);
    return RSR_SUCCESS;
} 


extern "C" 
int LINKDLL StartRecording(TCHAR* pathname,
                            size_t pathnameSize,
                            StatusCallbackPtr fPtr,
                            TCHAR* errorMessage,
                            size_t errorMessageSize)
{
    TCHAR buf[1024];
	sprintf(buf,"start recording to: %s",pathname);
	if(!GetEnvironmentVariable(RSR_EXT_STUB_SILENT,&buf2,0))
		MessageBox(NULL, buf,"", MB_OK);
    
    
    TCHAR* fileName = new TCHAR[pathnameSize + 5];
    _tcscpy(fileName, pathname);
    _tcscat(fileName, ".xml");
    ofstream of (fileName);
    if (of)
        of << "<?xml version=\"1.0\" ?>\n<Sample>\n </Sample>" << endl;

    fPtr(RSR_CALLBACK_PROGRESS, "I am doing OK");
    
    return RSR_SUCCESS;
}


extern "C" 
int LINKDLL StopRecording(TCHAR* errorMessage, 
                          size_t errorMessageSize)
{
    if(!GetEnvironmentVariable(RSR_EXT_STUB_SILENT,&buf2,0))
		MessageBox(NULL, "StopRecording",
                       "Hello from Custom Recording Adapter Stub!", MB_OK);
    TCHAR* msg = "Couldn't Stop!!!";
    if (_tcslen(msg) > errorMessageSize)
        return RSR_BUFFER_TOO_SHORT;
    _tcscpy(errorMessage, msg);
    return RSR_SUCCESS;
}


